\section{Automated Application Deployment}
This chapter mainly focuses on the operation of kubernetes cluster with the help of a gitlab repository.

\subsection{Declaring Deployment Environment}
Environment variable can describe where the code gets deployed. An environment can be linked to a kubernetes cluster. The environments can be linked in the CI/CD file in order to execute a deployment to a selected environement.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{gitlabenvironment}
  \caption{GitLab Environment}
\end{figure}

\subsection{Deploying Tokens and pulling Secrets}
We need to give K8s some authentication information so that it can pull the docker image from our GitLab project and ist container registry. In order to be able to do that we need to configure an authentication token (deploy token). This deploy token, consist of username and password and can directly be integrate with the help of environment variables into the GitLab pipeline.

\subsection{Dynamic environments and review apps}
We can work with multiple branches for the deployment of for example a test branch and the main branch on the kubernetes cluster. In order to differentiate the different resource on the cluster we can use a "DEPLOY\_SUFFIX" variable in the pipeline.

"CI\_COMMIT\_REF\_SLUG" will take the branch name and put it in a form that is valid for a K8s name. A new environment will be created dynamically in order to match the name of the branch.

The job stop\_review cleans up all the kubernetes ressources for this particular environment once the branch is deleted.
The "GIT\_STRATEGY" is set to none meaning that the code doesn’t have to be checked out in order to do the cleanup because it should be able to cleanup the code once the branch is deleted (branch not anymore available for checkout)



\section{Application Quality Monitoring}
\subsection{Integration and Functional Testing}
\begin{description}
  \item[Integration Test] testing how the different parts of the application integrate with each-other.
  \item[Functional Test] testing from the perspective of the user.
\end{description}


In order to do functional tests, we can use a review app or we can run an instance of the database in the build of GitLab CI using the concept of services. A service is an extra container that GitLab CI will run for us as part of our build or test process. This extra container is going to be available to the main container.

\subsection{Analysing Code Quality}
Adding Code Quality job in the build pipeline, which will check the code quality every time the pipeline runs, is a good idea for monitoring. A static tool scans the code as it exists on the disk in order to find potential bugs or style issues. Additionally make sure that the code checker runs in parallel to the rest in order not to block the main purpose of the pipeline. An example for this would be SonarQube which can be directly linked into the GitLab pipeline.

In our case the GitLab docker image does produce a JSON artefact which we can use in the pipeline. This is a premium feature of gitlab.

\subsection{Dynamic Application Security Testing (DAST)}
Static application security testing is scanning the codebase to try to identify potential security flaws. On the other hand dynamic tests are run against the real application. With GitLab CI, we can add dynamic security testing into our build pipeline by leveraging the review app capabilities. Is often done in a new stage with the name "dast". This job can also generate a json report which is the artefact of this job.

\subsection{Application Monitoring with Prometheus}
Prometheus identifies metric endpoints from an application and scrapes periodically metrics from those endpoints. We have to add prometheus metric endpoints to our application so that Prometheus can pull the metric data. Prometheus knows how to query the Kubernetes API server and asks for available endpoints. The annotations will inform Prometheus that a metric endpoint is available.

\section{Custom CI infrastructure}

\subsection{Launch Dedicated Runners}
So far all our pipeline build have used the shared runners provided on gitlab.com. But we might want to run our own dedicated servers. We might need more runner resources that are available from the shared runners on gitlab.com. For example we could also use an Amazon EC2 instance as a gitlab runner. If we install our own private GitLab server, we will also have to install runners.

With the help of tags we can assign job to a particular runner. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.6\textwidth]{runner}
  \caption{GitLab CI Runner}
\end{figure}

\subsection{Automatic Runner Deployment}
We would like to have a way to automatically deploy a runner so that we can replace it quickly if there is a failure, so that we can scale quickly if we have demands for more builds and always so that we can control the configuration of the runners. For this an Ansible playbook could be used. There is also the option to use custom kubernetes runners.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{gitlabrunners}
  \caption{GitLab Runners}
\end{figure}


\subsection{Autoscaling Runners using Cloud Resources}
Lets disable the shared runners so that we can be sure that GitLab uses our runners. This GitLab CI build happened on our Autoscaler. The docker machine executor reached out to AWS, requested a new EC2 instance, installed docker in that instance, used that instance to run the build and shut that instance back down again.

